//importing data
	  Promise.all([
		d3.csv('https://vizhub.com/Mike191/datasets/state-earthquakes.csv'),
	    d3.json('https://vizhub.com/Mike191/datasets/states-10m.json')
	  ]).then(([csvData, topoJASONdata]) => {
	    
	    var regionname = {};
	    var earthquakesnum = {};
	    var earthquakesnumlog = {};
	      
	    csvData.forEach(d => {
	      
	      regionname[d.States] = d.Region;
	      earthquakesnum[d.States] = d["Total Earthquakes"];
	      d["Total Earthquakes"] = Math.log((+d["Total Earthquakes"])+1);
	      earthquakesnumlog[d.States] = d["Total Earthquakes"];
		});
		  
	    
	    //setting variables
	    var svg = d3.select('svg');
	  	var projection = d3.geoAlbersUsa();
	    var states = topojson.feature(topoJASONdata, topoJASONdata.objects.states);
	    var colorScale = d3.scaleThreshold();  
		var colors = d => earthquakesnumlog[d.properties.name];
		

	    
	    //setting the colorscale
	   	colorScale
	    	.domain([0, 1, 2, 3, 4, 5, 6, 7, 8])
			.range(d3.schemeOrRd[9]);
				
	    
	    //creating the chloropleth
	    svg.selectAll('path')
	    	.data(states.features)
	      .enter()
	      .append('path')
	    	//drawing the sates
	    	.attr('class', 'state')
	    	.attr('d', d3.geoPath().projection(projection))
	    			.attr('fill', d => colorScale(colors(d)))
			.on('mouseover', tip.show)
			.on('mouseout', tip.hide);


		//adding label above legend
			svg.append('text')
			.attr('class', 'caption')
			.attr('x', 830)
			.attr('y', 190)
			.text('Earthquake Frequency');

	    //creating a legend
	    var colorLegend = (selection, props) => {
			var { colorScale} = props;
			
			var groups = selection.selectAll('g')
			  .data(colorScale.domain());
			
			var groupsEnter = groups.enter().append('g');
			
			groupsEnter
			  .merge(groups)
				.attr('transform', (d, i) =>
				  `translate(10, ${i * 20})`
				);
			groups.exit().remove();
			
			//creating the squares for the legend
			groupsEnter.append('rect')
			  .merge(groups.select('rect'))
				.attr('y', -15)  //positioning the squares to be lined up with the text
				.attr('height', 15)
				.attr('width', 15)
				.attr('fill', colorScale);

			
			//adding the text
			groupsEnter.append('text')
			  .merge(groups.select('text'))
				.text()
				.attr('x', 30);  //changes the spacing between text and squares
			  };
			
			//adding the legend
			svg.append('g')
			  .attr('transform', `translate(830, 220)`)
			  .call(colorLegend, {
				colorScale,
				circleRadius: 30
			  });


	  });




